const zipObject = require('lodash/zipObject');
const isNil = require('lodash/isNil');
const identity = require('lodash/identity');

const simpleAction = (type, createPayload) => function(...params) {
    return isNil(createPayload)
        ? { type }
        : { type, payload: createPayload(...params) };
}

const namedParameters = (...names) => (...params) => zipObject(names, params);

const singleParameterAction = type => simpleAction(type, identity);

module.exports = {simpleAction, namedParameters, singleParameterAction};
